'use strict';

var t = require('@babel/types');
var Option = require('effect/Option');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);
var Option__namespace = /*#__PURE__*/_interopNamespaceCompat(Option);

const maybeCallExpression = (node) => {
    return node.pipe(Option__namespace.flatMap((x) => t__namespace.isCallExpression(x.init) ? Option__namespace.some([x, x.init]) : Option__namespace.none()));
};
const maybeImportDeclaration = (binding) => {
    return binding.pipe(Option__namespace.flatMap((x) => x.path.parentPath &&
        t__namespace.isImportDeclaration(x.path.parentPath.node) &&
        x.path.parentPath.node.source.value.toLowerCase() === 'react'
        ? Option__namespace.some(true)
        : Option__namespace.none()));
};
const maybeReactIdent = (node) => {
    return node.pipe(Option__namespace.flatMap((x) => {
        if (t__namespace.isIdentifier(x.object, { name: 'react' }) ||
            t__namespace.isIdentifier(x.object, { name: 'React' })) {
            return Option__namespace.some(x.object);
        }
        if (t__namespace.isMemberExpression(x.object) &&
            t__namespace.isIdentifier(x.object.object, { name: '_react' }) &&
            t__namespace.isIdentifier(x.object.property, { name: 'default' })) {
            return Option__namespace.some(x.object.object);
        }
        return Option__namespace.none();
    }));
};
const maybeCreateElementExpression = (path) => {
    if (t__namespace.isIdentifier(path.node.property, { name: 'createElement' })) {
        return Option__namespace.some(path.node);
    }
    return Option__namespace.none();
};
const maybeBinding = (node, path) => {
    return node.pipe(Option__namespace.flatMap((a) => Option__namespace.fromNullable(path.scope.getBinding(a.name))));
};
const maybeVariableDeclarator = (binding) => {
    return binding.pipe(Option__namespace.flatMap((x) => x.path.isVariableDeclarator() ? Option__namespace.some(x.path.node) : Option__namespace.none()));
};

exports.maybeBinding = maybeBinding;
exports.maybeCallExpression = maybeCallExpression;
exports.maybeCreateElementExpression = maybeCreateElementExpression;
exports.maybeImportDeclaration = maybeImportDeclaration;
exports.maybeReactIdent = maybeReactIdent;
exports.maybeVariableDeclarator = maybeVariableDeclarator;
//# sourceMappingURL=babel.maps.js.map
