'use strict';

var path = require('path');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var path__default = /*#__PURE__*/_interopDefaultCompat(path);

const METRO_ENDPOINT = `__native_twin_update_endpoint`;
const INTERNAL_RESET = Symbol();
const INTERNAL_SET = Symbol();
const INTERNAL_FLAGS = Symbol();
const DEFAULT_CONTAINER_NAME = '@__';
const STYLE_SCOPES = {
    /** @description Style is the same globally */
    GLOBAL: 0,
    /** @description Style is the same within a context (variables / containers) */
    CONTEXT: 1,
    /** @description Style can affect other styles (sets variables, uses other styles) */
    SELF: 2,
};
const transformKeys = new Set([
    'perspective',
    'translateX',
    'translateY',
    'rotate',
    'rotateX',
    'rotateY',
    'rotateZ',
    'scale',
    'scaleX',
    'scaleY',
    'skewX',
    'skewY',
]);
// export const TWIN_MODULES_CACHE_DIR = 'node_modules';
// export const TWIN_CACHE_DIR = ['node_modules', '.cache', 'native-twin'].join(path.sep);
const TWIN_CACHE_DIR_RUNTIME = ['.cache', 'native-twin'].join(path__default.default.sep);
const TWIN_CSS_FILES = [
    'twin.out.css',
    'twin.out.web.css',
    'twin.out.ios.css.js',
    'twin.out.android.css.js',
    'twin.out.native.css.js',
];
const TWIN_INPUT_CSS_FILE = 'twin.in.css';
const platformVariants = ['web', 'native', 'ios', 'android'];
const twinModuleExportString = 'module.exports = new Map([])';
const TWIN_GLOBAL_SHEET_IMPORT_NAME = '__twinGlobal__sheet';
// export const twinHMRString =
//   "require('@native-twin/metro/build/config/server/poll-update-client')";

exports.DEFAULT_CONTAINER_NAME = DEFAULT_CONTAINER_NAME;
exports.INTERNAL_FLAGS = INTERNAL_FLAGS;
exports.INTERNAL_RESET = INTERNAL_RESET;
exports.INTERNAL_SET = INTERNAL_SET;
exports.METRO_ENDPOINT = METRO_ENDPOINT;
exports.STYLE_SCOPES = STYLE_SCOPES;
exports.TWIN_CACHE_DIR_RUNTIME = TWIN_CACHE_DIR_RUNTIME;
exports.TWIN_CSS_FILES = TWIN_CSS_FILES;
exports.TWIN_GLOBAL_SHEET_IMPORT_NAME = TWIN_GLOBAL_SHEET_IMPORT_NAME;
exports.TWIN_INPUT_CSS_FILE = TWIN_INPUT_CSS_FILE;
exports.platformVariants = platformVariants;
exports.transformKeys = transformKeys;
exports.twinModuleExportString = twinModuleExportString;
//# sourceMappingURL=twin.constants.js.map
