import path from 'path';

const METRO_ENDPOINT = `__native_twin_update_endpoint`;
const INTERNAL_RESET = Symbol();
const INTERNAL_SET = Symbol();
const INTERNAL_FLAGS = Symbol();
const DEFAULT_CONTAINER_NAME = '@__';
const STYLE_SCOPES = {
    /** @description Style is the same globally */
    GLOBAL: 0,
    /** @description Style is the same within a context (variables / containers) */
    CONTEXT: 1,
    /** @description Style can affect other styles (sets variables, uses other styles) */
    SELF: 2,
};
const transformKeys = new Set([
    'perspective',
    'translateX',
    'translateY',
    'rotate',
    'rotateX',
    'rotateY',
    'rotateZ',
    'scale',
    'scaleX',
    'scaleY',
    'skewX',
    'skewY',
]);
// export const TWIN_MODULES_CACHE_DIR = 'node_modules';
// export const TWIN_CACHE_DIR = ['node_modules', '.cache', 'native-twin'].join(path.sep);
const TWIN_CACHE_DIR_RUNTIME = ['.cache', 'native-twin'].join(path.sep);
const TWIN_CSS_FILES = [
    'twin.out.css',
    'twin.out.web.css',
    'twin.out.ios.css.js',
    'twin.out.android.css.js',
    'twin.out.native.css.js',
];
const TWIN_INPUT_CSS_FILE = 'twin.in.css';
const platformVariants = ['web', 'native', 'ios', 'android'];
const twinModuleExportString = 'module.exports = new Map([])';
const TWIN_GLOBAL_SHEET_IMPORT_NAME = '__twinGlobal__sheet';
// export const twinHMRString =
//   "require('@native-twin/metro/build/config/server/poll-update-client')";

export { DEFAULT_CONTAINER_NAME, INTERNAL_FLAGS, INTERNAL_RESET, INTERNAL_SET, METRO_ENDPOINT, STYLE_SCOPES, TWIN_CACHE_DIR_RUNTIME, TWIN_CSS_FILES, TWIN_GLOBAL_SHEET_IMPORT_NAME, TWIN_INPUT_CSS_FILE, platformVariants, transformKeys, twinModuleExportString };
//# sourceMappingURL=twin.constants.js.map
