import * as Equal from 'effect/Equal';
import { pipe } from 'effect/Function';
import * as Hash from 'effect/Hash';

class TwinBabelFile {
    data;
    tree;
    constructor(data, tree) {
        this.data = data;
        this.tree = tree;
    }
    [Equal.symbol](that) {
        return that instanceof TwinBabelFile && this.data.filename === that.data.filename;
    }
    [Hash.symbol]() {
        return pipe(Hash.string(this.data.filename), Hash.combine(Hash.string(this.data.platform)), Hash.combine(Hash.string(this.data.type)));
    }
}

export { TwinBabelFile };
//# sourceMappingURL=BabelFile.model.js.map
