'use strict';

var t = require('@babel/types');
var Console = require('effect/Console');
var Option = require('effect/Option');
var babel = require('../babel');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);
var Console__namespace = /*#__PURE__*/_interopNamespaceCompat(Console);
var Option__namespace = /*#__PURE__*/_interopNamespaceCompat(Option);

const debugEffect = (x) => Console__namespace.log(x);
const isCreateElementIdent = (node) => {
    return t__namespace.isIdentifier(node.property, { name: 'createElement' });
};
const getReactIdent = (x) => {
    if (t__namespace.isIdentifier(x.node.object, { name: 'react' }) ||
        t__namespace.isIdentifier(x.node.object, { name: 'React' })) {
        return x.node.object.name;
    }
    if (t__namespace.isMemberExpression(x.node.object) &&
        t__namespace.isIdentifier(x.node.object.object, { name: '_react' }) &&
        t__namespace.isIdentifier(x.node.object.property, { name: 'default' })) {
        return x.node.object.object.name;
    }
    return null;
};
const isReactRequireBinding = (x) => {
    if (x.path.isVariableDeclarator() && t__namespace.isCallExpression(x.path.node.init)) {
        if (t__namespace.isIdentifier(x.path.node.init.callee, { name: 'require' }) &&
            t__namespace.isStringLiteral(x.path.node.init.arguments[0], { value: 'react' })) {
            return true;
        }
        else if (
        // const <name> = _interopRequireDefault(require("react"))
        t__namespace.isIdentifier(x.path.node.init.callee, { name: '_interopRequireDefault' }) &&
            t__namespace.isCallExpression(x.path.node.init.arguments[0]) &&
            t__namespace.isIdentifier(x.path.node.init.arguments[0].callee, { name: 'require' }) &&
            t__namespace.isStringLiteral(x.path.node.init.arguments[0].arguments[0], {
                value: 'react',
            })) {
            return true;
        }
    }
    return false;
};
const isReactImport = (x) => {
    if (x.path.isImportSpecifier() ||
        x.path.isImportDefaultSpecifier() ||
        x.path.isImportDeclaration() ||
        x.path.isImportNamespaceSpecifier()) {
        return (t__namespace.isImportDeclaration(x.path.parentPath.node) &&
            x.path.parentPath.node.source.value.toLowerCase() === 'react');
    }
    return false;
};
const pipeMemberExpression = (self) => {
    return Option__namespace.Do.pipe(() => (isCreateElementIdent(self.node) ? Option__namespace.some(self) : Option__namespace.none()), Option__namespace.flatMapNullable(getReactIdent), Option__namespace.flatMapNullable((x) => self.scope.getBinding(x)), Option__namespace.map((x) => isReactRequireBinding(x) || isReactImport(x)), Option__namespace.getOrElse(() => false));
};
const maybeBindingIsReactImport = (x) => x.pipe(babel.maybeVariableDeclarator, babel.maybeCallExpression, (node) => [babel.isReactRequire(node), babel.isReactInteropRequire(node)], Option__namespace.firstSomeOf);

exports.debugEffect = debugEffect;
exports.getReactIdent = getReactIdent;
exports.isReactImport = isReactImport;
exports.isReactRequireBinding = isReactRequireBinding;
exports.maybeBindingIsReactImport = maybeBindingIsReactImport;
exports.pipeMemberExpression = pipeMemberExpression;
//# sourceMappingURL=import.utils.js.map
