'use strict';

var t = require('@babel/types');
var RA = require('effect/Array');
var Function = require('effect/Function');
var HashMap = require('effect/HashMap');
var Option = require('effect/Option');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);
var RA__namespace = /*#__PURE__*/_interopNamespaceCompat(RA);
var HashMap__namespace = /*#__PURE__*/_interopNamespaceCompat(HashMap);
var Option__namespace = /*#__PURE__*/_interopNamespaceCompat(Option);

const elementNodeToTree = (treeNode, filename) => {
    const childs = Function.pipe(treeNode.childs, RA__namespace.fromIterable, RA__namespace.map((x) => elementNodeToTree(x, filename)));
    const props = [
        t__namespace.objectProperty(t__namespace.identifier('jsxElementName'), t__namespace.stringLiteral(treeNode.leave.elementName)),
        t__namespace.objectProperty(t__namespace.identifier('order'), t__namespace.numericLiteral(treeNode.leave.order)),
        t__namespace.objectProperty(t__namespace.identifier('parentNode'), t__namespace.nullLiteral()),
        t__namespace.objectProperty(t__namespace.identifier('childs'), t__namespace.arrayExpression(childs)),
        t__namespace.objectProperty(t__namespace.identifier('id'), t__namespace.stringLiteral(treeNode.leave.id)),
        t__namespace.objectProperty(t__namespace.identifier('filename'), t__namespace.stringLiteral(filename)),
        t__namespace.objectProperty(t__namespace.identifier('source'), t__namespace.stringLiteral(treeNode.leave.source.source)),
        t__namespace.objectProperty(t__namespace.identifier('importKind'), t__namespace.stringLiteral(treeNode.leave.source.kind)),
    ];
    return t__namespace.objectExpression(props);
};
const createDevToolsTree = (registries, babelTrees) => Function.pipe(babelTrees, RA__namespace.map((babelTree) => Function.pipe(HashMap__namespace.get(registries, babelTree.root.value.uid), Option__namespace.map((registry) => ({
    ...registry,
    childs: flatLeaveChilds(registries, registry.leave.leave),
})))), RA__namespace.getSomes);
const flatLeaveChilds = (trees, node) => {
    return Function.pipe(node.children, RA__namespace.map((child) => Function.pipe(HashMap__namespace.get(trees, child.value.uid), Option__namespace.map((treeElement) => ({
        ...treeElement,
        childs: flatLeaveChilds(trees, child),
    })))), RA__namespace.getSomes);
};

exports.createDevToolsTree = createDevToolsTree;
exports.elementNodeToTree = elementNodeToTree;
//# sourceMappingURL=jsx.debug.js.map
