'use strict';

var t = require('@babel/types');
var Function = require('effect/Function');
var Predicate = require('effect/Predicate');

function _interopNamespaceCompat(e) {
	if (e && typeof e === 'object' && 'default' in e) return e;
	var n = Object.create(null);
	if (e) {
		Object.keys(e).forEach(function (k) {
			if (k !== 'default') {
				var d = Object.getOwnPropertyDescriptor(e, k);
				Object.defineProperty(n, k, d.get ? d : {
					enumerable: true,
					get: function () { return e[k]; }
				});
			}
		});
	}
	n.default = e;
	return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);
var Predicate__namespace = /*#__PURE__*/_interopNamespaceCompat(Predicate);

const isJSXElement = Function.pipe((node) => t__namespace.isJSXElement(node), Predicate__namespace.mapInput((node) => node));
const isJSXElementNode = (node) => t__namespace.isJSXElement(node);
const isCallExpression = (node) => t__namespace.isNode(node) && t__namespace.isCallExpression(node);
const isVariableDeclaratorPath = (path) => path.isVariableDeclarator();
const variableDeclaratorIsRequire = Function.pipe((path) => path.isCallExpression());
const isImportSpecifier = Function.pipe((path) => path.isImportSpecifier());
const isImportDeclaration = Function.pipe((path) => path.isImportDeclaration());
const isJSXElementPath = (node) => node.isJSXElement();
const isJSXAttribute = (node) => t__namespace.isJSXAttribute(node);
const isJSXAttributePath = (node) => node.isJSXAttribute();

exports.isCallExpression = isCallExpression;
exports.isImportDeclaration = isImportDeclaration;
exports.isImportSpecifier = isImportSpecifier;
exports.isJSXAttribute = isJSXAttribute;
exports.isJSXAttributePath = isJSXAttributePath;
exports.isJSXElement = isJSXElement;
exports.isJSXElementNode = isJSXElementNode;
exports.isJSXElementPath = isJSXElementPath;
exports.isVariableDeclaratorPath = isVariableDeclaratorPath;
exports.variableDeclaratorIsRequire = variableDeclaratorIsRequire;
//# sourceMappingURL=jsx.predicates.js.map
