'use strict';

var Context = require('effect/Context');
var Effect = require('effect/Effect');
var Layer = require('effect/Layer');
var twin = require('../jsx/twin');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var Context__namespace = /*#__PURE__*/_interopNamespaceCompat(Context);
var Effect__namespace = /*#__PURE__*/_interopNamespaceCompat(Effect);
var Layer__namespace = /*#__PURE__*/_interopNamespaceCompat(Layer);

class NativeTwinService extends Context__namespace.Tag('babel/twin-service')() {
    static make = (options) => Layer__namespace.scoped(NativeTwinService, Effect__namespace.gen(function* () {
        const platform = options.platform;
        const twinConfig = twin.getUserTwinConfig(options.projectRoot, {
            engine: 'hermes',
            isDev: options.dev,
            isServer: options.platform === 'web',
            platform: options.platform,
        });
        // console.log('DEFINED_PREFLIGHT: ', twinConfig.preflight);
        const preflight = {};
        if (options.platform === 'web') {
            twinConfig.mode = 'web';
        }
        // twinConfig.preflight = {};
        const twin$1 = twin.setupNativeTwin(twinConfig, {
            engine: 'hermes',
            isDev: options.dev,
            isServer: options.platform === 'web',
            platform: options.platform,
        });
        return {
            tw: twin$1,
            config: twinConfig,
            preflight,
            context: {
                baseRem: twin$1.config.root.rem ?? 16,
                platform,
            },
        };
    }));
}

exports.NativeTwinService = NativeTwinService;
//# sourceMappingURL=NativeTwin.service.js.map
