'use strict';

var Context = require('effect/Context');
var Function = require('effect/Function');
var Layer = require('effect/Layer');
var MutableHashMap = require('effect/MutableHashMap');
var Option = require('effect/Option');
var BabelFile_model = require('../models/BabelFile.model');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var Context__namespace = /*#__PURE__*/_interopNamespaceCompat(Context);
var Layer__namespace = /*#__PURE__*/_interopNamespaceCompat(Layer);
var MutableHashMap__namespace = /*#__PURE__*/_interopNamespaceCompat(MutableHashMap);
var Option__namespace = /*#__PURE__*/_interopNamespaceCompat(Option);

const babelCache = MutableHashMap__namespace.empty();
const getOrSetBabelFile = (file, tree) => {
    return Function.pipe(babelCache, MutableHashMap__namespace.get(file.filename), Option__namespace.getOrElse(() => {
        const newFile = new BabelFile_model.TwinBabelFile(file, tree);
        Function.pipe(babelCache, MutableHashMap__namespace.set(file.filename, newFile));
        return newFile;
    }));
};
class BabelCacheContext extends Context__namespace.Tag('transformer/babel-cache-context')() {
    static Live = Layer__namespace.succeed(BabelCacheContext, {
        cache: babelCache,
        getOrSetBabelFile,
    });
}

exports.BabelCacheContext = BabelCacheContext;
exports.babelCache = babelCache;
//# sourceMappingURL=babel.cache.js.map
