'use strict';

var jitiFactory = require('jiti');
var sucrase = require('sucrase');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var jitiFactory__default = /*#__PURE__*/_interopDefaultCompat(jitiFactory);

let jiti = null;
function lazyJiti() {
    return (jiti ??
        (jiti = jitiFactory__default.default(__filename, {
            interopDefault: true,
            transform: (opts) => {
                return sucrase.transform(opts.source, {
                    transforms: ['typescript', 'imports'],
                });
            },
        })));
}
function requireJS(path) {
    const config = (function () {
        try {
            return path ? require(path) : {};
        }
        catch {
            return lazyJiti()(path);
        }
    })();
    return config.default ?? config;
}

exports.requireJS = requireJS;
//# sourceMappingURL=load-js.js.map
